#COMPILE EXE

FUNCTION PBMAIN () AS LONG
    IF COMMAND$ = "" THEN LINE INPUT  "Source file  [ALL.TXT]  ",fi$ ELSE fi$ = COMMAND$
    NBase% = 25
    NegThresh% = 12

    IF fi$ = "" THEN fi$ = "ALL.TXT"
    IF DIR$(fi$) = "" THEN PRINT fi$ & " Does not exist" : END
    OPEN fi$ FOR INPUT AS #1
    WHILE NOT EOF(1)
        LINE INPUT #1, l$
        Message$ = MID$(l$ , 37 , 13)
        IF MID$(Message$ , 7 , 1)  <> "-"  THEN ITERATE LOOP            'No valid message
        IF INSTR (MID$(l$, 11 , 5), "/") > 0 THEN ITERATE LOOP    'Averages that give a meaningless message result

        tim$ = LEFT$(l$ , 4)
        sn% = VAL(MID$(l$ , 11, 4))
        df% = VAL(MID$(l$ , 21 , 5))

        la& = ASC(MID$(Message$ , 1 , 1))-65
        IF la& >= NegThresh% THEN la& = la& - NegThresh%
        la& = NBase% * la& + ASC(MID$(Message$ , 2 , 1))-65
        la& = NBase% * la& + ASC(MID$(Message$ , 3 , 1))-65
        la& = NBase% * la& + ASC(MID$(Message$ , 4 , 1))-65
        la& = NBase% * la& + ASC(MID$(Message$ , 5 , 1))-65
        la& = NBase% * la& + ASC(MID$(Message$ , 6 , 1))-65

        LatDeg& = INT(la& / 600000)
        LatMin# = (la& - LatDeg& * 600000) / 10000
        Lat# = LatDeg& + LatMin# / 60
        IF ASC(MID$(Message$, 1, 1)) - 65 >= NegThresh% THEN Lat# = -Lat#

        IF latdeg& > 90 THEN ITERATE LOOP                   'Bodged way of trapping out the false codes generted
                                                            '   Remove when that is sorted
        la& = ASC(MID$(Message$ , 8 , 1))-65
        IF la& >= NegThresh% THEN la& = la& - NegThresh%
        la& = NBase% * la& + ASC(MID$(Message$ , 9 , 1))-65
        la& = NBase% * la& + ASC(MID$(Message$ , 10 , 1))-65
        la& = NBase% * la& + ASC(MID$(Message$ , 11 , 1))-65
        la& = NBase% * la& + ASC(MID$(Message$ , 12 , 1))-65
        la& = NBase% * la& + ASC(MID$(Message$ , 13 , 1))-65

        LonDeg& = INT(la& / 600000)
        LonMin# = (la& - LonDeg& * 600000) / 10000
        Lon# = LonDeg& + LonMin# / 60
        IF ASC(MID$(Message$, 8, 1)) - 65 >= NegThresh% THEN Lon# = -Lon#

        CALL GenNGR(Lat#, Lon#, ngr$)


        PRINT USING$("\  \   \           \  +##.##### +###.#####  \        \  +##.#dB  +###Hz \  \ ",tim$ , Message$, lat#,lon#, NGR$, sn%, df%,tim$)

    WEND
    WHILE NOT INSTAT : WEND


END FUNCTION

SUB GenNGR(k#, l#, ngr$)
    DEFDBL a - z
    dr = 180 / 3.141592653589
     'first convert lat/long to northing / easting

    IF k < 49 OR k > 61 OR l < -8 OR l > 1.8 THEN
        ngr$ = ""
        EXIT SUB
    END IF
    a1 = 6377563.396 * 0.9996012717
    b1 = 6356256.91 * 0.9996012717
    n1 = (a1 - b1) / (a1 + b1)
    e2 = (a1 ^ 2 - b1 ^ 2) / a1 ^ 2
    k3 = (k - 49) / dr
    k4 = (k + 49) / dr
    k1 = k / dr
    j3 = (1 + n1 + 5 / 4 * n1 ^ 2 + 5 / 4 * n1 ^ 3) * k3
    j4 = (3 * n1 + 3 * n1 ^ 2 + 21 / 8 * n1 ^ 3) * SIN(k3) * COS(k4)
    j5 = (15 / 8 * n1 ^ 2 + 15 / 8 * n1 ^ 3) * SIN(2 * k3) * COS(2 * k4)
    j6 = 35 / 24 * n1 ^ 3 * SIN(3 * k3) * COS(3 * k4)
    m = b1 * (j3 - j4 + j5 - j6)
    v = a1 / SQR(1 - e2 * SIN(k1) ^ 2)
    r = v * (1 - e2) / (1 - e2 * SIN(k1) ^ 2)
    h2 = v / r - 1

    p = (l + 2) / dr
    j3 = m - 100000
    j4 = v / 2 * SIN(k1) * COS(k1)
    j5 = v / 24 * SIN(k1) * COS(k1) ^ 3 * (5 - TAN(k1) ^ 2 + 9 * h2)
    j6 = v / 720 * SIN(k1) * COS(k1) ^ 5 * (61 - 58 * TAN(k) ^ 2 + TAN(k1) ^ 4)
    n = j3 + p ^ 2 * j4 + p ^ 4 * j5 + p ^ 6 * j6

    j7 = v * COS(k1)
    j8 = v / 6 * COS(k1) ^ 3 * (v / r - TAN(k1) ^ 2)
    j9 = v / 120 * COS(k1) ^ 5
    j9 = j9 * (5 - 18 * TAN(k1) ^ 2 + TAN(k1) ^ 4 + 14 * h2 - 58 * TAN(k1) ^ 2 * h2)
    e = 400000 + p * j7 + p ^ 3 * j8 + p ^ 5 * j9

    'convert EN to NGR

    IF e <= 0 OR e > 700000# OR n <= 0 OR n > 1400000# THEN ngr$ = "Not valid": EXIT SUB
    IF Resolution# > 2 THEN
        Ndiv% = 1000
        Ndigits% = 2
    ELSE
        Ndiv% = 100
        Ndigits% = 3
    END IF

    IF Resolution# < 0.1 THEN
        Ndiv% = 10
        Ndigits% = 4
    END IF


    easting1% = e \ 100000
    northing1% = n \ 100000
    C1% = 83 - 5 * (northing1% \ 5) + (easting1% \ 5)
    IF C1% = 73 THEN C1% = 72
    eh% = (easting1% MOD 5)
    nh% = (northing1% MOD 5)
    C2% = (4 - nh%) * 5 + eh% + 65
    IF C2% > 72 THEN C2% = C2% + 1
    easting2& = (e - easting1% * 100000) / Ndiv%
    northing2& = (n - northing1% * 100000) / Ndiv%
    CE$ = MID$(STR$(easting2&), 2)
    DO WHILE LEN(CE$) < Ndigits%
        CE$ = "0" + CE$
    LOOP
    CN$ = MID$(STR$(northing2&), 2)
    DO WHILE LEN(CN$) < Ndigits%
        CN$ = "0" + CN$
    LOOP
    ngr$ = CHR$(C1%) + CHR$(C2%) + CE$ + CN$

END SUB
